Imports System.IO

Public Class CFileChopper

    Private Const MAXFIELDSPEROUTPUTFILE As Integer = 256

    Private m_FileNameToConvert As String
    Private m_sr As StreamReader
    Private m_NumberOfFilesToCreate As Integer
    Private m_Columnnames() As String

    Public Sub New(ByVal FileName As String)
        Me.m_FileNameToConvert = FileName
        m_sr = CreateStreamReader(Me.m_FileNameToConvert)
        m_Columnnames = CreateColumnNameArray(m_sr)
        If ((m_Columnnames.Length - 1) Mod (MAXFIELDSPEROUTPUTFILE - 1)) = 0 Then
            m_NumberOfFilesToCreate = ((m_Columnnames.Length - 1) / (MAXFIELDSPEROUTPUTFILE - 1))
        Else
            m_NumberOfFilesToCreate = ((m_Columnnames.Length - 1) / (MAXFIELDSPEROUTPUTFILE - 1)) + 1
        End If
        m_sr.Close()
    End Sub

    Private Function CreateStreamReader(ByVal filename) As StreamReader
        Dim fs As New FileStream(filename, FileMode.Open, FileAccess.Read)
        m_sr = New StreamReader(fs)
        Return m_sr
    End Function

    Private Function CreateColumnNameArray(ByVal sr As StreamReader) As String()
        Dim FirstRow As String
        FirstRow = sr.ReadLine
        Dim ColumnNames() As String = FirstRow.Split(ControlChars.Tab)
        Dim i As Integer
        Return ColumnNames
    End Function

    Public ReadOnly Property NumberOfFilesToCreate() As Integer
        Get
            Return m_NumberOfFilesToCreate
        End Get
    End Property

    Public Function CreateChoppedFiles() As String
        Dim FileNamesCreated = ""
        Dim i As Integer
        Dim PartialOutputFileName As String
        PartialOutputFileName = Path.GetDirectoryName(Me.m_FileNameToConvert) & "\" & Path.GetFileNameWithoutExtension(Me.m_FileNameToConvert)
        For i = 1 To m_NumberOfFilesToCreate
            m_sr = CreateStreamReader(Me.m_FileNameToConvert)
            Dim mincolumnnumber As Integer = 2 + ((i - 1) * (MAXFIELDSPEROUTPUTFILE - 1))
            Dim maxcolumnnumber As Integer = mincolumnnumber + MAXFIELDSPEROUTPUTFILE - 2
            If maxcolumnnumber > m_Columnnames.Length Then
                maxcolumnnumber = m_Columnnames.Length
            End If
            'MessageBox.Show(mincolumnnumber & " - " & maxcolumnnumber)
            Dim newfilename As String = PartialOutputFileName & Chr(65 + i - 1) & Path.GetExtension(Me.m_FileNameToConvert)
            Dim sw As New StreamWriter(newfilename, False)
            Dim nextline As String
            nextline = m_sr.ReadLine()
            Do Until nextline = "" Or IsNothing(nextline)
                Dim DataFieldData() As String = nextline.Split(ControlChars.Tab)
                sw.Write(DataFieldData(0))
                Dim col As Integer
                For col = mincolumnnumber - 1 To maxcolumnnumber - 1
                    sw.Write(ControlChars.Tab & DataFieldData(col))
                Next
                sw.Write(ControlChars.CrLf)
                nextline = m_sr.ReadLine()
            Loop
            m_sr.Close()
            sw.Close()
            If FileNamesCreated = "" Then
                FileNamesCreated = newfilename
            Else
                FileNamesCreated = FileNamesCreated & "; " & ControlChars.CrLf & newfilename
            End If
        Next
        Return FileNamesCreated
    End Function
End Class
